diff --git a/src/backend/snowball/libstemmer/stem_KOI8_R_russian.c b/src/backend/snowball/libstemmer/stem_KOI8_R_russian.c
index be7feb752e..fea26a66cf 100644
--- a/src/backend/snowball/libstemmer/stem_KOI8_R_russian.c
+++ b/src/backend/snowball/libstemmer/stem_KOI8_R_russian.c
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #include "header.h"
 
@@ -340,20 +340,11 @@ static const struct among a_7[4] =
 
 static const unsigned char g_v[] = { 35, 130, 34, 18 };
 
-static const symbol s_0[] = { 0xC1 };
-static const symbol s_1[] = { 0xD1 };
-static const symbol s_2[] = { 0xC1 };
-static const symbol s_3[] = { 0xD1 };
-static const symbol s_4[] = { 0xC1 };
-static const symbol s_5[] = { 0xD1 };
-static const symbol s_6[] = { 0xCE };
-static const symbol s_7[] = { 0xCE };
-static const symbol s_8[] = { 0xCE };
-static const symbol s_9[] = { 0xC9 };
+static const symbol s_0[] = { 0xC5 };
 
-static int r_mark_regions(struct SN_env * z) {
-    z->I[0] = z->l;
-    z->I[1] = z->l;
+static int r_mark_regions(struct SN_env * z) { /* forwardmode */
+    z->I[0] = z->l; /* $pV = <integer expression>, line 61 */
+    z->I[1] = z->l; /* $p2 = <integer expression>, line 62 */
     {   int c1 = z->c; /* do, line 63 */
         {    /* gopast */ /* grouping v, line 64 */
             int ret = out_grouping(z, g_v, 192, 220, 1);
@@ -383,27 +374,28 @@ static int r_mark_regions(struct SN_env * z) {
     return 1;
 }
 
-static int r_R2(struct SN_env * z) {
-    if (!(z->I[1] <= z->c)) return 0;
+static int r_R2(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[1] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 71 */
     return 1;
 }
 
-static int r_perfective_gerund(struct SN_env * z) {
+static int r_perfective_gerund(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 74 */
-    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((25166336 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_0, 9); /* substring, line 74 */
+    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((25166336 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 74 */
+    among_var = find_among_b(z, a_0, 9);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 74 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 74 */
         case 1:
             {   int m1 = z->l - z->c; (void)m1; /* or, line 78 */
-                if (!(eq_s_b(z, 1, s_0))) goto lab1;
+                if (z->c <= z->lb || z->p[z->c - 1] != 0xC1) goto lab1; /* literal, line 78 */
+                z->c--;
                 goto lab0;
             lab1:
                 z->c = z->l - m1;
-                if (!(eq_s_b(z, 1, s_1))) return 0;
+                if (z->c <= z->lb || z->p[z->c - 1] != 0xD1) return 0; /* literal, line 78 */
+                z->c--;
             }
         lab0:
             {   int ret = slice_del(z); /* delete, line 78 */
@@ -419,45 +411,38 @@ static int r_perfective_gerund(struct SN_env * z) {
     return 1;
 }
 
-static int r_adjective(struct SN_env * z) {
-    int among_var;
+static int r_adjective(struct SN_env * z) { /* backwardmode */
     z->ket = z->c; /* [, line 90 */
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((2271009 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_1, 26); /* substring, line 90 */
-    if (!(among_var)) return 0;
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((2271009 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 90 */
+    if (!(find_among_b(z, a_1, 26))) return 0;
     z->bra = z->c; /* ], line 90 */
-    switch(among_var) {
-        case 0: return 0;
-        case 1:
-            {   int ret = slice_del(z); /* delete, line 99 */
-                if (ret < 0) return ret;
-            }
-            break;
+    {   int ret = slice_del(z); /* delete, line 99 */
+        if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_adjectival(struct SN_env * z) {
+static int r_adjectival(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int ret = r_adjective(z);
-        if (ret == 0) return 0; /* call adjective, line 104 */
-        if (ret < 0) return ret;
+    {   int ret = r_adjective(z); /* call adjective, line 104 */
+        if (ret <= 0) return ret;
     }
-    {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 111 */
+    {   int m1 = z->l - z->c; (void)m1; /* try, line 111 */
         z->ket = z->c; /* [, line 112 */
-        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((671113216 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->c = z->l - m_keep; goto lab0; }
-        among_var = find_among_b(z, a_2, 8); /* substring, line 112 */
-        if (!(among_var)) { z->c = z->l - m_keep; goto lab0; }
+        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((671113216 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->c = z->l - m1; goto lab0; } /* substring, line 112 */
+        among_var = find_among_b(z, a_2, 8);
+        if (!(among_var)) { z->c = z->l - m1; goto lab0; }
         z->bra = z->c; /* ], line 112 */
-        switch(among_var) {
-            case 0: { z->c = z->l - m_keep; goto lab0; }
+        switch (among_var) { /* among, line 112 */
             case 1:
-                {   int m1 = z->l - z->c; (void)m1; /* or, line 117 */
-                    if (!(eq_s_b(z, 1, s_2))) goto lab2;
+                {   int m2 = z->l - z->c; (void)m2; /* or, line 117 */
+                    if (z->c <= z->lb || z->p[z->c - 1] != 0xC1) goto lab2; /* literal, line 117 */
+                    z->c--;
                     goto lab1;
                 lab2:
-                    z->c = z->l - m1;
-                    if (!(eq_s_b(z, 1, s_3))) { z->c = z->l - m_keep; goto lab0; }
+                    z->c = z->l - m2;
+                    if (z->c <= z->lb || z->p[z->c - 1] != 0xD1) { z->c = z->l - m1; goto lab0; } /* literal, line 117 */
+                    z->c--;
                 }
             lab1:
                 {   int ret = slice_del(z); /* delete, line 117 */
@@ -476,40 +461,34 @@ static int r_adjectival(struct SN_env * z) {
     return 1;
 }
 
-static int r_reflexive(struct SN_env * z) {
-    int among_var;
+static int r_reflexive(struct SN_env * z) { /* backwardmode */
     z->ket = z->c; /* [, line 131 */
-    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 209 && z->p[z->c - 1] != 216)) return 0;
-    among_var = find_among_b(z, a_3, 2); /* substring, line 131 */
-    if (!(among_var)) return 0;
+    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 209 && z->p[z->c - 1] != 216)) return 0; /* substring, line 131 */
+    if (!(find_among_b(z, a_3, 2))) return 0;
     z->bra = z->c; /* ], line 131 */
-    switch(among_var) {
-        case 0: return 0;
-        case 1:
-            {   int ret = slice_del(z); /* delete, line 134 */
-                if (ret < 0) return ret;
-            }
-            break;
+    {   int ret = slice_del(z); /* delete, line 134 */
+        if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_verb(struct SN_env * z) {
+static int r_verb(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 139 */
-    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((51443235 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_4, 46); /* substring, line 139 */
+    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((51443235 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 139 */
+    among_var = find_among_b(z, a_4, 46);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 139 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 139 */
         case 1:
             {   int m1 = z->l - z->c; (void)m1; /* or, line 145 */
-                if (!(eq_s_b(z, 1, s_4))) goto lab1;
+                if (z->c <= z->lb || z->p[z->c - 1] != 0xC1) goto lab1; /* literal, line 145 */
+                z->c--;
                 goto lab0;
             lab1:
                 z->c = z->l - m1;
-                if (!(eq_s_b(z, 1, s_5))) return 0;
+                if (z->c <= z->lb || z->p[z->c - 1] != 0xD1) return 0; /* literal, line 145 */
+                z->c--;
             }
         lab0:
             {   int ret = slice_del(z); /* delete, line 145 */
@@ -525,69 +504,56 @@ static int r_verb(struct SN_env * z) {
     return 1;
 }
 
-static int r_noun(struct SN_env * z) {
-    int among_var;
+static int r_noun(struct SN_env * z) { /* backwardmode */
     z->ket = z->c; /* [, line 162 */
-    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((60991267 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_5, 36); /* substring, line 162 */
-    if (!(among_var)) return 0;
+    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((60991267 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 162 */
+    if (!(find_among_b(z, a_5, 36))) return 0;
     z->bra = z->c; /* ], line 162 */
-    switch(among_var) {
-        case 0: return 0;
-        case 1:
-            {   int ret = slice_del(z); /* delete, line 169 */
-                if (ret < 0) return ret;
-            }
-            break;
+    {   int ret = slice_del(z); /* delete, line 169 */
+        if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_derivational(struct SN_env * z) {
-    int among_var;
+static int r_derivational(struct SN_env * z) { /* backwardmode */
     z->ket = z->c; /* [, line 178 */
-    if (z->c - 2 <= z->lb || (z->p[z->c - 1] != 212 && z->p[z->c - 1] != 216)) return 0;
-    among_var = find_among_b(z, a_6, 2); /* substring, line 178 */
-    if (!(among_var)) return 0;
+    if (z->c - 2 <= z->lb || (z->p[z->c - 1] != 212 && z->p[z->c - 1] != 216)) return 0; /* substring, line 178 */
+    if (!(find_among_b(z, a_6, 2))) return 0;
     z->bra = z->c; /* ], line 178 */
-    {   int ret = r_R2(z);
-        if (ret == 0) return 0; /* call R2, line 178 */
+    {   int ret = r_R2(z); /* call R2, line 178 */
+        if (ret <= 0) return ret;
+    }
+    {   int ret = slice_del(z); /* delete, line 181 */
         if (ret < 0) return ret;
     }
-    switch(among_var) {
-        case 0: return 0;
-        case 1:
-            {   int ret = slice_del(z); /* delete, line 181 */
-                if (ret < 0) return ret;
-            }
-            break;
-    }
     return 1;
 }
 
-static int r_tidy_up(struct SN_env * z) {
+static int r_tidy_up(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 186 */
-    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((151011360 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_7, 4); /* substring, line 186 */
+    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 6 || !((151011360 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 186 */
+    among_var = find_among_b(z, a_7, 4);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 186 */
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 186 */
         case 1:
             {   int ret = slice_del(z); /* delete, line 190 */
                 if (ret < 0) return ret;
             }
             z->ket = z->c; /* [, line 191 */
-            if (!(eq_s_b(z, 1, s_6))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 0xCE) return 0; /* literal, line 191 */
+            z->c--;
             z->bra = z->c; /* ], line 191 */
-            if (!(eq_s_b(z, 1, s_7))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 0xCE) return 0; /* literal, line 191 */
+            z->c--;
             {   int ret = slice_del(z); /* delete, line 191 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            if (!(eq_s_b(z, 1, s_8))) return 0;
+            if (z->c <= z->lb || z->p[z->c - 1] != 0xCE) return 0; /* literal, line 194 */
+            z->c--;
             {   int ret = slice_del(z); /* delete, line 194 */
                 if (ret < 0) return ret;
             }
@@ -601,94 +567,117 @@ static int r_tidy_up(struct SN_env * z) {
     return 1;
 }
 
-extern int russian_KOI8_R_stem(struct SN_env * z) {
-    {   int c1 = z->c; /* do, line 203 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab0; /* call mark_regions, line 203 */
-            if (ret < 0) return ret;
+extern int russian_KOI8_R_stem(struct SN_env * z) { /* forwardmode */
+    {   int c1 = z->c; /* do, line 205 */
+        while(1) { /* repeat, line 205 */
+            int c2 = z->c;
+            while(1) { /* goto, line 205 */
+                int c3 = z->c;
+                z->bra = z->c; /* [, line 205 */
+                if (z->c == z->l || z->p[z->c] != 0xA3) goto lab2; /* literal, line 205 */
+                z->c++;
+                z->ket = z->c; /* ], line 205 */
+                z->c = c3;
+                break;
+            lab2:
+                z->c = c3;
+                if (z->c >= z->l) goto lab1;
+                z->c++; /* goto, line 205 */
+            }
+            {   int ret = slice_from_s(z, 1, s_0); /* <-, line 205 */
+                if (ret < 0) return ret;
+            }
+            continue;
+        lab1:
+            z->c = c2;
+            break;
         }
-    lab0:
         z->c = c1;
     }
-    z->lb = z->c; z->c = z->l; /* backwards, line 204 */
+    /* do, line 207 */
+    {   int ret = r_mark_regions(z); /* call mark_regions, line 207 */
+        if (ret == 0) goto lab3;
+        if (ret < 0) return ret;
+    }
+lab3:
+    z->lb = z->c; z->c = z->l; /* backwards, line 208 */
 
-    {   int mlimit; /* setlimit, line 204 */
-        int m2 = z->l - z->c; (void)m2;
+
+    {   int mlimit4; /* setlimit, line 208 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 204 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m2;
-        {   int m3 = z->l - z->c; (void)m3; /* do, line 205 */
-            {   int m4 = z->l - z->c; (void)m4; /* or, line 206 */
-                {   int ret = r_perfective_gerund(z);
-                    if (ret == 0) goto lab3; /* call perfective_gerund, line 206 */
+        mlimit4 = z->lb; z->lb = z->I[0];
+        {   int m5 = z->l - z->c; (void)m5; /* do, line 209 */
+            {   int m6 = z->l - z->c; (void)m6; /* or, line 210 */
+                {   int ret = r_perfective_gerund(z); /* call perfective_gerund, line 210 */
+                    if (ret == 0) goto lab6;
                     if (ret < 0) return ret;
                 }
-                goto lab2;
-            lab3:
-                z->c = z->l - m4;
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 207 */
-                    {   int ret = r_reflexive(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab4; } /* call reflexive, line 207 */
+                goto lab5;
+            lab6:
+                z->c = z->l - m6;
+                {   int m7 = z->l - z->c; (void)m7; /* try, line 211 */
+                    {   int ret = r_reflexive(z); /* call reflexive, line 211 */
+                        if (ret == 0) { z->c = z->l - m7; goto lab7; }
                         if (ret < 0) return ret;
                     }
-                lab4:
-                    ;
-                }
-                {   int m5 = z->l - z->c; (void)m5; /* or, line 208 */
-                    {   int ret = r_adjectival(z);
-                        if (ret == 0) goto lab6; /* call adjectival, line 208 */
-                        if (ret < 0) return ret;
-                    }
-                    goto lab5;
-                lab6:
-                    z->c = z->l - m5;
-                    {   int ret = r_verb(z);
-                        if (ret == 0) goto lab7; /* call verb, line 208 */
-                        if (ret < 0) return ret;
-                    }
-                    goto lab5;
                 lab7:
-                    z->c = z->l - m5;
-                    {   int ret = r_noun(z);
-                        if (ret == 0) goto lab1; /* call noun, line 208 */
+                    ;
+                }
+                {   int m8 = z->l - z->c; (void)m8; /* or, line 212 */
+                    {   int ret = r_adjectival(z); /* call adjectival, line 212 */
+                        if (ret == 0) goto lab9;
+                        if (ret < 0) return ret;
+                    }
+                    goto lab8;
+                lab9:
+                    z->c = z->l - m8;
+                    {   int ret = r_verb(z); /* call verb, line 212 */
+                        if (ret == 0) goto lab10;
+                        if (ret < 0) return ret;
+                    }
+                    goto lab8;
+                lab10:
+                    z->c = z->l - m8;
+                    {   int ret = r_noun(z); /* call noun, line 212 */
+                        if (ret == 0) goto lab4;
                         if (ret < 0) return ret;
                     }
                 }
-            lab5:
+            lab8:
                 ;
             }
-        lab2:
-        lab1:
-            z->c = z->l - m3;
+        lab5:
+        lab4:
+            z->c = z->l - m5;
         }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 211 */
-            z->ket = z->c; /* [, line 211 */
-            if (!(eq_s_b(z, 1, s_9))) { z->c = z->l - m_keep; goto lab8; }
-            z->bra = z->c; /* ], line 211 */
-            {   int ret = slice_del(z); /* delete, line 211 */
+        {   int m9 = z->l - z->c; (void)m9; /* try, line 215 */
+            z->ket = z->c; /* [, line 215 */
+            if (z->c <= z->lb || z->p[z->c - 1] != 0xC9) { z->c = z->l - m9; goto lab11; } /* literal, line 215 */
+            z->c--;
+            z->bra = z->c; /* ], line 215 */
+            {   int ret = slice_del(z); /* delete, line 215 */
                 if (ret < 0) return ret;
             }
-        lab8:
+        lab11:
             ;
         }
-        {   int m6 = z->l - z->c; (void)m6; /* do, line 214 */
-            {   int ret = r_derivational(z);
-                if (ret == 0) goto lab9; /* call derivational, line 214 */
+        {   int m10 = z->l - z->c; (void)m10; /* do, line 218 */
+            {   int ret = r_derivational(z); /* call derivational, line 218 */
+                if (ret == 0) goto lab12;
                 if (ret < 0) return ret;
             }
-        lab9:
-            z->c = z->l - m6;
+        lab12:
+            z->c = z->l - m10;
         }
-        {   int m7 = z->l - z->c; (void)m7; /* do, line 215 */
-            {   int ret = r_tidy_up(z);
-                if (ret == 0) goto lab10; /* call tidy_up, line 215 */
+        {   int m11 = z->l - z->c; (void)m11; /* do, line 219 */
+            {   int ret = r_tidy_up(z); /* call tidy_up, line 219 */
+                if (ret == 0) goto lab13;
                 if (ret < 0) return ret;
             }
-        lab10:
-            z->c = z->l - m7;
+        lab13:
+            z->c = z->l - m11;
         }
-        z->lb = mlimit;
+        z->lb = mlimit4;
     }
     z->c = z->lb;
     return 1;
diff --git a/src/backend/snowball/libstemmer/stem_UTF_8_danish.c b/src/backend/snowball/libstemmer/stem_UTF_8_danish.c
index cfd41376da..4f7e3016bb 100644
--- a/src/backend/snowball/libstemmer/stem_UTF_8_danish.c
+++ b/src/backend/snowball/libstemmer/stem_UTF_8_danish.c
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #include "header.h"
 
@@ -132,15 +132,15 @@ static const symbol s_0[] = { 's', 't' };
 static const symbol s_1[] = { 'i', 'g' };
 static const symbol s_2[] = { 'l', 0xC3, 0xB8, 's' };
 
-static int r_mark_regions(struct SN_env * z) {
-    z->I[0] = z->l;
-    {   int c_test = z->c; /* test, line 33 */
-        {   int ret = skip_utf8(z->p, z->c, 0, z->l, + 3);
+static int r_mark_regions(struct SN_env * z) { /* forwardmode */
+    z->I[0] = z->l; /* $p1 = <integer expression>, line 31 */
+    {   int c_test1 = z->c; /* test, line 33 */
+        {   int ret = skip_utf8(z->p, z->c, 0, z->l, + 3); /* hop, line 33 */
             if (ret < 0) return 0;
-            z->c = ret; /* hop, line 33 */
+            z->c = ret;
         }
         z->I[1] = z->c; /* setmark x, line 33 */
-        z->c = c_test;
+        z->c = c_test1;
     }
     if (out_grouping_U(z, g_v, 97, 248, 1) < 0) return 0; /* goto */ /* grouping v, line 34 */
     {    /* gopast */ /* non v, line 34 */
@@ -149,37 +149,34 @@ static int r_mark_regions(struct SN_env * z) {
         z->c += ret;
     }
     z->I[0] = z->c; /* setmark p1, line 34 */
-     /* try, line 35 */
-    if (!(z->I[0] < z->I[1])) goto lab0;
-    z->I[0] = z->I[1];
+    /* try, line 35 */
+    if (!(z->I[0] < z->I[1])) goto lab0; /* $(<integer expression> < <integer expression>), line 35 */
+    z->I[0] = z->I[1]; /* $p1 = <integer expression>, line 35 */
 lab0:
     return 1;
 }
 
-static int r_main_suffix(struct SN_env * z) {
+static int r_main_suffix(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int mlimit; /* setlimit, line 41 */
-        int m1 = z->l - z->c; (void)m1;
+
+    {   int mlimit1; /* setlimit, line 41 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 41 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
+        mlimit1 = z->lb; z->lb = z->I[0];
         z->ket = z->c; /* [, line 41 */
-        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1851440 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->lb = mlimit; return 0; }
-        among_var = find_among_b(z, a_0, 32); /* substring, line 41 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
+        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1851440 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->lb = mlimit1; return 0; } /* substring, line 41 */
+        among_var = find_among_b(z, a_0, 32);
+        if (!(among_var)) { z->lb = mlimit1; return 0; }
         z->bra = z->c; /* ], line 41 */
-        z->lb = mlimit;
+        z->lb = mlimit1;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 42 */
         case 1:
             {   int ret = slice_del(z); /* delete, line 48 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            if (in_grouping_b_U(z, g_s_ending, 97, 229, 0)) return 0;
+            if (in_grouping_b_U(z, g_s_ending, 97, 229, 0)) return 0; /* grouping s_ending, line 50 */
             {   int ret = slice_del(z); /* delete, line 50 */
                 if (ret < 0) return ret;
             }
@@ -188,21 +185,19 @@ static int r_main_suffix(struct SN_env * z) {
     return 1;
 }
 
-static int r_consonant_pair(struct SN_env * z) {
-    {   int m_test = z->l - z->c; /* test, line 55 */
-        {   int mlimit; /* setlimit, line 56 */
-            int m1 = z->l - z->c; (void)m1;
+static int r_consonant_pair(struct SN_env * z) { /* backwardmode */
+    {   int m_test1 = z->l - z->c; /* test, line 55 */
+
+        {   int mlimit2; /* setlimit, line 56 */
             if (z->c < z->I[0]) return 0;
-            z->c = z->I[0]; /* tomark, line 56 */
-            mlimit = z->lb; z->lb = z->c;
-            z->c = z->l - m1;
+            mlimit2 = z->lb; z->lb = z->I[0];
             z->ket = z->c; /* [, line 56 */
-            if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 100 && z->p[z->c - 1] != 116)) { z->lb = mlimit; return 0; }
-            if (!(find_among_b(z, a_1, 4))) { z->lb = mlimit; return 0; } /* substring, line 56 */
+            if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 100 && z->p[z->c - 1] != 116)) { z->lb = mlimit2; return 0; } /* substring, line 56 */
+            if (!(find_among_b(z, a_1, 4))) { z->lb = mlimit2; return 0; }
             z->bra = z->c; /* ], line 56 */
-            z->lb = mlimit;
+            z->lb = mlimit2;
         }
-        z->c = z->l - m_test;
+        z->c = z->l - m_test1;
     }
     {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
         if (ret < 0) return 0;
@@ -215,41 +210,38 @@ static int r_consonant_pair(struct SN_env * z) {
     return 1;
 }
 
-static int r_other_suffix(struct SN_env * z) {
+static int r_other_suffix(struct SN_env * z) { /* backwardmode */
     int among_var;
     {   int m1 = z->l - z->c; (void)m1; /* do, line 66 */
         z->ket = z->c; /* [, line 66 */
-        if (!(eq_s_b(z, 2, s_0))) goto lab0;
+        if (!(eq_s_b(z, 2, s_0))) goto lab0; /* literal, line 66 */
         z->bra = z->c; /* ], line 66 */
-        if (!(eq_s_b(z, 2, s_1))) goto lab0;
+        if (!(eq_s_b(z, 2, s_1))) goto lab0; /* literal, line 66 */
         {   int ret = slice_del(z); /* delete, line 66 */
             if (ret < 0) return ret;
         }
     lab0:
         z->c = z->l - m1;
     }
-    {   int mlimit; /* setlimit, line 67 */
-        int m2 = z->l - z->c; (void)m2;
+
+    {   int mlimit2; /* setlimit, line 67 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 67 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m2;
+        mlimit2 = z->lb; z->lb = z->I[0];
         z->ket = z->c; /* [, line 67 */
-        if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1572992 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->lb = mlimit; return 0; }
-        among_var = find_among_b(z, a_2, 5); /* substring, line 67 */
-        if (!(among_var)) { z->lb = mlimit; return 0; }
+        if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1572992 >> (z->p[z->c - 1] & 0x1f)) & 1)) { z->lb = mlimit2; return 0; } /* substring, line 67 */
+        among_var = find_among_b(z, a_2, 5);
+        if (!(among_var)) { z->lb = mlimit2; return 0; }
         z->bra = z->c; /* ], line 67 */
-        z->lb = mlimit;
+        z->lb = mlimit2;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 68 */
         case 1:
             {   int ret = slice_del(z); /* delete, line 70 */
                 if (ret < 0) return ret;
             }
             {   int m3 = z->l - z->c; (void)m3; /* do, line 70 */
-                {   int ret = r_consonant_pair(z);
-                    if (ret == 0) goto lab1; /* call consonant_pair, line 70 */
+                {   int ret = r_consonant_pair(z); /* call consonant_pair, line 70 */
+                    if (ret == 0) goto lab1;
                     if (ret < 0) return ret;
                 }
             lab1:
@@ -265,19 +257,17 @@ static int r_other_suffix(struct SN_env * z) {
     return 1;
 }
 
-static int r_undouble(struct SN_env * z) {
-    {   int mlimit; /* setlimit, line 76 */
-        int m1 = z->l - z->c; (void)m1;
+static int r_undouble(struct SN_env * z) { /* backwardmode */
+
+    {   int mlimit1; /* setlimit, line 76 */
         if (z->c < z->I[0]) return 0;
-        z->c = z->I[0]; /* tomark, line 76 */
-        mlimit = z->lb; z->lb = z->c;
-        z->c = z->l - m1;
+        mlimit1 = z->lb; z->lb = z->I[0];
         z->ket = z->c; /* [, line 76 */
-        if (out_grouping_b_U(z, g_v, 97, 248, 0)) { z->lb = mlimit; return 0; }
+        if (out_grouping_b_U(z, g_v, 97, 248, 0)) { z->lb = mlimit1; return 0; } /* non v, line 76 */
         z->bra = z->c; /* ], line 76 */
         z->S[0] = slice_to(z, z->S[0]); /* -> ch, line 76 */
         if (z->S[0] == 0) return -1; /* -> ch, line 76 */
-        z->lb = mlimit;
+        z->lb = mlimit1;
     }
     if (!(eq_v_b(z, z->S[0]))) return 0; /* name ch, line 77 */
     {   int ret = slice_del(z); /* delete, line 78 */
@@ -286,10 +276,10 @@ static int r_undouble(struct SN_env * z) {
     return 1;
 }
 
-extern int danish_UTF_8_stem(struct SN_env * z) {
+extern int danish_UTF_8_stem(struct SN_env * z) { /* forwardmode */
     {   int c1 = z->c; /* do, line 84 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab0; /* call mark_regions, line 84 */
+        {   int ret = r_mark_regions(z); /* call mark_regions, line 84 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
@@ -298,32 +288,32 @@ extern int danish_UTF_8_stem(struct SN_env * z) {
     z->lb = z->c; z->c = z->l; /* backwards, line 85 */
 
     {   int m2 = z->l - z->c; (void)m2; /* do, line 86 */
-        {   int ret = r_main_suffix(z);
-            if (ret == 0) goto lab1; /* call main_suffix, line 86 */
+        {   int ret = r_main_suffix(z); /* call main_suffix, line 86 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
     lab1:
         z->c = z->l - m2;
     }
     {   int m3 = z->l - z->c; (void)m3; /* do, line 87 */
-        {   int ret = r_consonant_pair(z);
-            if (ret == 0) goto lab2; /* call consonant_pair, line 87 */
+        {   int ret = r_consonant_pair(z); /* call consonant_pair, line 87 */
+            if (ret == 0) goto lab2;
             if (ret < 0) return ret;
         }
     lab2:
         z->c = z->l - m3;
     }
     {   int m4 = z->l - z->c; (void)m4; /* do, line 88 */
-        {   int ret = r_other_suffix(z);
-            if (ret == 0) goto lab3; /* call other_suffix, line 88 */
+        {   int ret = r_other_suffix(z); /* call other_suffix, line 88 */
+            if (ret == 0) goto lab3;
             if (ret < 0) return ret;
         }
     lab3:
         z->c = z->l - m4;
     }
     {   int m5 = z->l - z->c; (void)m5; /* do, line 89 */
-        {   int ret = r_undouble(z);
-            if (ret == 0) goto lab4; /* call undouble, line 89 */
+        {   int ret = r_undouble(z); /* call undouble, line 89 */
+            if (ret == 0) goto lab4;
             if (ret < 0) return ret;
         }
     lab4:
